%%
% Copyright (c) 2017 - 2021, Pascal Wagler;
% Copyright (c) 2014 - 2021, John MacFarlane
%
% All rights reserved.
%
% Redistribution and use in source and binary forms, with or without
% modification, are permitted provided that the following conditions
% are met:
%
% - Redistributions of source code must retain the above copyright
% notice, this list of conditions and the following disclaimer.
%
% - Redistributions in binary form must reproduce the above copyright
% notice, this list of conditions and the following disclaimer in the
% documentation and/or other materials provided with the distribution.
%
% - Neither the name of John MacFarlane nor the names of other
% contributors may be used to endorse or promote products derived
% from this software without specific prior written permission.
%
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
% "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
% LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
% FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
% COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
% INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
% CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
% LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
% ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
% POSSIBILITY OF SUCH DAMAGE.
%%

%%
% Adapted from the Eisvogel pandoc LaTeX template for ctuthesis.cls
%%

% Options for packages loaded elsewhere
\PassOptionsToPackage{unicode$for(hyperrefoptions)$,$hyperrefoptions$$endfor$}{hyperref}
\PassOptionsToPackage{hyphens}{url}
\PassOptionsToPackage{dvipsnames,svgnames,x11names,table}{xcolor}
$if(dir)$
$if(latex-dir-rtl)$
\PassOptionsToPackage{RTLdocument}{bidi}
$endif$
$endif$
$if(CJKmainfont)$
\PassOptionsToPackage{space}{xeCJK}
$endif$
%
\documentclass[twoside]{ctuthesis}

\ctusetup{
  pkg-hyperref = false,
$if(preprint)$ preprint = $preprint$,
$endif$$if(mainlanguage)$ mainlanguage = {$mainlanguage$},
$endif$$if(titlelanguage)$ titlelanguage = {$titlelanguage$},
$endif$$if(otherlanguages)$ otherlanguages = {$otherlanguages$},
$endif$$if(title-czech)$ title-czech = {$title-czech$},
$endif$$if(title-english)$ title-english = {$title-english$},
$endif$$if(subtitle-czech)$ subtitle-czech = {$subtitle-czech$},
$endif$$if(subtitle-english)$ subtitle-english = {$subtitle-english$},
$endif$$if(doctype)$ doctype = {$doctype$},
$endif$$if(faculty)$ faculty = {$faculty$},
$endif$$if(department-czech)$ department-czech = {$department-czech$},
$endif$$if(department-english)$ department-english = {$department-english$},
$endif$$if(author)$ author = {$author$},
$endif$$if(supervisor)$ supervisor = {$supervisor$},
$endif$$if(supervisor-address)$ supervisor-address = {$supervisor-address$},
$endif$$if(supervisor-specialist)$ supervisor-specialist = {$supervisor-specialist$},
$endif$$if(fieldofstudy-english)$ fieldofstudy-english = {$fieldofstudy-english$},
$endif$$if(subfieldofstudy-english)$ subfieldofstudy-english = {$subfieldofstudy-english$},
$endif$$if(fieldofstudy-czech)$ fieldofstudy-czech = {$fieldofstudy-czech$},
$endif$$if(subfieldofstudy-czech)$ subfieldofstudy-czech = {$subfieldofstudy-czech$},
$endif$$if(keywords-czech)$ keywords-czech = {$keywords-czech$},
$endif$$if(keywords-english)$ keywords-english = {$keywords-english$},
$endif$$if(day)$ day = {$day$},
$endif$$if(month)$ month = {$month$},
$endif$$if(year)$ year = {$year$},
$endif$$if(specification-file)$ specification-file = {$specification-file$},
$endif$$if(front-specification)$ front-specification = {$front-specification$},
$endif$$if(front-list-of-figures)$ front-list-of-figures = {$front-list-of-figures$},
$endif$$if(front-list-of-tables)$ front-list-of-tables = {$front-list-of-tables$},
$endif$$if(monochrome)$ monochrome = {$monochrome$},
$endif$$if(layout-short)$ layout-short = {$layout-short$},
$endif$}
\ctuprocess

\addto\ctucaptionsczech{%
	\def\supervisorname{Vedoucí}%
	\def\subfieldofstudyname{Studijní program}%
}
\setcounter{tocdepth}{$table-of-contents-depth$}
% Theorem declarations, this is the reasonable default, anybody can do what they wish.
% If you prefer theorems in italics rather than slanted, use \theoremstyle{plainit}
\theoremstyle{plain}
\newtheorem{theorem}{Theorem}[chapter]
\newtheorem{corollary}[theorem]{Corollary}
\newtheorem{lemma}[theorem]{Lemma}
\newtheorem{proposition}[theorem]{Proposition}

\theoremstyle{definition}
\newtheorem{definition}[theorem]{Definition}
\newtheorem{example}[theorem]{Example}
\newtheorem{conjecture}[theorem]{Conjecture}

\theoremstyle{note}
\newtheorem*{remark*}{Remark}
\newtheorem{remark}[theorem]{Remark}

% This makes floating graphics stick to the subsections where they belong
% https://www.overleaf.com/learn/latex/Questions/How_can_I_get_my_table_or_figure_to_stay_where_they_are%2C_instead_of_going_to_the_next_page%3F
% https://tex.stackexchange.com/questions/118662/use-placeins-for-subsections
\usepackage{placeins}
\makeatletter
\AtBeginDocument{%
  \expandafter\renewcommand\expandafter\subsection\expandafter
    {\expandafter\@fb@secFB\subsection}%
  \newcommand\@fb@secFB{\FloatBarrier
    \gdef\@fb@afterHHook{\@fb@topbarrier \gdef\@fb@afterHHook{}}}%
  \g@addto@macro\@afterheading{\@fb@afterHHook}%
  \gdef\@fb@afterHHook{}%
}
\makeatother

\usepackage{hyperref}
\hypersetup{
$if(title-english)$ pdftitle = {$title-english$},
$else$$if(title-czech)$ pdftitle = {$title-czech$},
$endif$$endif$$if(author)$  pdfauthor = {$author$},
$endif$  pdfusetitle,
  colorlinks=false,
  linktocpage=true,
  allbordercolors=ctuorange,
  pdfpagelayout=TwoPageRight,
}
\usepackage{lmodern}
\usepackage{amssymb,amsmath}
\usepackage{ifxetex,ifluatex}
\ifnum 0\ifxetex 1\fi\ifluatex 1\fi=0 % if pdftex
  \usepackage[T1]{fontenc}
  \usepackage[utf8]{inputenc}
\else % if luatex or xelatex
  \ifxetex
    \usepackage{mathspec}
    \usepackage{xltxtra,xunicode}
  \else
    \usepackage{fontspec}
  \fi
  \defaultfontfeatures{Mapping=tex-text,Scale=MatchLowercase}
  \newcommand{\euro}{€}
\fi
% use upquote if available, for straight quotes in verbatim environments
\IfFileExists{upquote.sty}{\usepackage{upquote}}{}
% use microtype if available
\IfFileExists{microtype.sty}{%
\usepackage{microtype}
\UseMicrotypeSet[protrusion]{basicmath} % disable protrusion for tt fonts
}{}
\usepackage{fancyvrb}
\VerbatimFootnotes
\usepackage{graphicx,grffile}
\makeatletter
\def\maxwidth{\ifdim\Gin@nat@width>\linewidth\linewidth\else\Gin@nat@width\fi}
\def\maxheight{\ifdim\Gin@nat@height>\textheight\textheight\else\Gin@nat@height\fi}
\makeatother
% Scale images if necessary, so that they will not overflow the page
% margins by default, and it is still possible to overwrite the defaults
% using explicit options in \includegraphics[width, height, ...]{}
\setkeys{Gin}{width=\maxwidth,height=\maxheight,keepaspectratio}
\usepackage[normalem]{ulem}
% avoid problems with \sout in headers with hyperref:
\pdfstringdefDisableCommands{\renewcommand{\sout}{}}
\setlength{\parindent}{0pt}
\setlength{\parskip}{6pt plus 2pt minus 1pt}
\setlength{\emergencystretch}{3em}  % prevent overfull lines
\providecommand{\tightlist}{%
  \setlength{\itemsep}{0pt}\setlength{\parskip}{0pt}}
\setcounter{secnumdepth}{2}
\VerbatimFootnotes % allows verbatim text in footnotes

% \usepackage[sort,square]{natbib}
% \newenvironment{CSLReferences}%
%   {\appendix
%   \begin{thebibliography}{1}}%
%   {\end{thebibliography}}
$if(csl-refs)$
  \newlength{\cslhangindent}
  \setlength{\cslhangindent}{1.5em}
  \newlength{\csllabelwidth}
  \setlength{\csllabelwidth}{3em}
  \newlength{\cslentryspacingunit} % times entry-spacing
  \setlength{\cslentryspacingunit}{\parskip}
  \newenvironment{CSLReferences}[2] % #1 hanging-ident, #2 entry spacing
   {\appendix
    \chapter{Bibliography}
    % don't indent paragraphs
    \setlength{\parindent}{0pt}
    % turn on hanging indent if param 1 is 1
    \ifodd #1
    \let\oldpar\par
    \def\par{\hangindent=\cslhangindent\oldpar}
    \fi
    % set entry spacing
    \setlength{\parskip}{#2\cslentryspacingunit}
   }%
   {}
  \usepackage{calc}
  \newcommand{\CSLBlock}[1]{#1\hfill\break}
  \newcommand{\CSLLeftMargin}[1]{\parbox[t]{\csllabelwidth}{#1}}
  \newcommand{\CSLRightInline}[1]{\parbox[t]{\linewidth - \csllabelwidth}{#1}\break}
  \newcommand{\CSLIndent}[1]{\hspace{\cslhangindent}#1}
$endif$
% \setcitestyle{numbers,square}

$header-includes$

\setlength{\parskip}{1ex}

% Abstract in Czech
$if(abstract-czech)$
\begin{abstract-czech}
    $abstract-czech$
\end{abstract-czech}
$endif$
% Abstract in English
$if(abstract-english)$
\begin{abstract-english}
    $abstract-english$
\end{abstract-english}
$endif$

% Acknowledgements / Podekovani
\begin{thanks}
$thanks$
%TODO add more %
\end{thanks}

% Declaration / Prohlaseni
\begin{declaration}
$if(declaration-english)$
$declaration-english$

\medskip

$author$

$time-date-english$

\vspace*{2cm}
$endif$
$if(declaration-czech)$
$declaration-czech$

\medskip

$author$

$time-date-czech$
$endif$
\end{declaration}


\begin{document}

\maketitle

$body$

% \bibliography{bibliography.bib}

% \ctutemplate{specification.as.chapter}

\end{document}
